Global iniLines
Global iniCmd$[512]
Global iniParm$[512]
GetINI()

Global frametick=MilliSecs()

Global SpriteWidth=1920	; SpriteWidth=FromINI(SpriteWidth,"Size","Width")
Global SpriteHeight=1080; SpriteHeight=FromINI(SpriteHeight,"Size","Height")

Global ScreenWidth=SpriteWidth
Global ScreenHeight=SpriteHeight


Global trail[5000]

Global Text$="Doctor Who"
Global FontID$="03-FontUsed-SFFlorencesansSC.ttf"

Global coloured=1

Global Rescale=0
	Temp$=Upper$(FromINItxt$("","Rescale","Make"))
	If temp$="TRUE" Or temp$="LARGER" Or temp$="BIGGER" Or temp$="GROW" Then Rescale=2
	If temp$="SMALLER" Or temp$="SHRINK" Then Rescale=1

	temp$=Trim$(fromINItxt$(temp$,"String","Text"))
	If Len(temp$)>1 Then text=temp$

	temp$=Trim$(fromINItxt$(fontid$,"Font"))
	If Len(temp$)>1 Then fontid=temp$

	temp$=Trim$(Upper$(fromINItxt$(temp$,"Output")))
	If temp$="WHITE" Then coloured=0
	If temp$="BLACK" Then coloured=-1

	
'	text="Doctor Who"
	
Global OutFilename$="Out"	;	OutFilename$=FromINItxt$(OutFilename$,"String","Text")

outfilename$=Replace(outfilename$,"/","_")
outfilename$=Replace(outfilename$,"\","_")
outfilename$=Replace(outfilename$,";","_")
outfilename$=Replace(outfilename$,":","_")
outfilename$=Replace(outfilename$,"*","_")
outfilename$=Replace(outfilename$,"?","_")
outfilename$=Replace(outfilename$,"!","_")
outfilename$=Replace(outfilename$,Chr$(34),"")


Global MaskColor=$000000


Global SpritesX=Floor(ScreenWidth/SpriteWidth)
Global SpritesY=Floor(ScreenHeight/SpriteHeight)

Function GetIni()
	iniLines=0
If FileType("settings.ini")=1	
	DebugLog "Found ini file"
	quickin=ReadFile("settings.ini")
	lines=0
	Repeat
		intxt$=ReadLine(quickin)
		If Instr(intxt,"=")
			cmd$=iniLeft$(intxt)
			parm$=iniRight(intxt)
			cmd=Trim$(cmd$)
			cmd=Replace$(cmd," ","")
			cmd=Lower$(cmd)
			parm$=Trim$(parm$)
			
			iniLines=iniLines+1
			iniCmd[iniLines]=cmd$
			iniParm[iniLines]=parm$
		EndIf
		
		If iniLines>500 Then fin=1
		If Eof(quickin) Then fin=1
	Until fin=1
	CloseFile quickin
EndIf
End Function

Function FromINI(value,va$="-1",vb$="-1",vc$="-1",vd$="-1",ve$="-1",vf$="-1",vg$="-1")
Local fout=value
va$=Lower$(Trim$(Replace$(va$," ","")))
vb$=Lower$(Trim$(Replace$(vb$," ","")))
vc$=Lower$(Trim$(Replace$(vc$," ","")))
vd$=Lower$(Trim$(Replace$(vd$," ","")))
ve$=Lower$(Trim$(Replace$(ve$," ","")))
vf$=Lower$(Trim$(Replace$(vf$," ","")))
vg$=Lower$(Trim$(Replace$(vg$," ","")))

For inie=1 To iniLines
	If va$=inicmd[inie] Then fout=Int(iniparm[inie])
	If vb$=inicmd[inie] Then fout=Int(iniparm[inie])
	If vc$=inicmd[inie] Then fout=Int(iniparm[inie])
	If vd$=inicmd[inie] Then fout=Int(iniparm[inie])
	If ve$=inicmd[inie] Then fout=Int(iniparm[inie])
	If vf$=inicmd[inie] Then fout=Int(iniparm[inie])
	If vg$=inicmd[inie] Then fout=Int(iniparm[inie])
Next

Return fout
End Function


Function FromINItxt$(value$,va$="-1",vb$="-1",vc$="-1",vd$="-1",ve$="-1",vf$="-1",vg$="-1")
Local fout$=value
va$=Lower$(Trim$(Replace$(va$," ","")))
vb$=Lower$(Trim$(Replace$(vb$," ","")))
vc$=Lower$(Trim$(Replace$(vc$," ","")))
vd$=Lower$(Trim$(Replace$(vd$," ","")))
ve$=Lower$(Trim$(Replace$(ve$," ","")))
vf$=Lower$(Trim$(Replace$(vf$," ","")))
vg$=Lower$(Trim$(Replace$(vg$," ","")))

For inie=1 To iniLines
	If va$=inicmd[inie] Then fout=iniparm[inie]
	If vb$=inicmd[inie] Then fout=iniparm[inie]
	If vc$=inicmd[inie] Then fout=iniparm[inie]
	If vd$=inicmd[inie] Then fout=iniparm[inie]
	If ve$=inicmd[inie] Then fout=iniparm[inie]
	If vf$=inicmd[inie] Then fout=iniparm[inie]
	If vg$=inicmd[inie] Then fout=iniparm[inie]
Next

Return fout
End Function



Function SplitText$(in$,Split$,e,alsospace=0)

	'Splits text...
	Local out:String=""
	Local start:Int=1
	Local nomore:Int=0
	Local shift:Int
	Local size:Int

	in:String=Trim(in)
	e=e-1
	
	For shift=1 To e
		If Instr(in$,Split$,start)+1<=nstart Then nomore=1
		If Instr(in$,Split$,start)+1>nstart Then nstart=Instr(in$,Split$,start)+1
		If AlsoSpace=1 Then If Instr(in$," ",start)+1<nstart And Instr(in$," ",start)>0 Then nstart=Instr(in$," ",start)+1
		start=nstart
	Next
	size=(Instr(in$,Split$,start))-start
	If AlsoSpace=1 Then If (Instr(in$," ",start))-start<size And Instr(in$," ",start)>0 Then size=(Instr(in$," ",start))-start
	

	out$=Mid$(in$,start,size)
	If nomore=1 Then out$="-+-"
	Return out
End Function

Function IniLeft$(ftxt$)
	Return Upper$(Trim$(splittext$(ftxt$,"=",1,0)))
End Function

Function IniRight$(ftxt$)
	Return Trim$(splittext$(ftxt$,"=",2,0))
End Function


Function Ink(ang#,bright#)
	Local fr#=(150+(Cos(ang)*150.0))*bright
	Local fg#=(150+(Cos(ang+240)*150.0))*bright
	Local fb#=(150+(Cos(ang+120)*150.0))*bright
	
	If fr<0 Then fr=0
	If fr>255 Then fr=255
	If fgr<0 Then fg=0
	If fg>255 Then fg=255
	If fb<0 Then fb=0
	If fb>255 Then fb=255
	SetColor(fr,fg,fb)
End Function


Function ResetDraw()
SetRotation 0
SetAlpha(1)
SetColor(255,255,255)
SetBlend(ALPHABLEND)
End Function

Graphics ScreenWidth,ScreenHeight,0

Global font[130]
For n=0 To 128
	font[n]=LoadImageFont("font/"+fontid$,32+(n*4),0)'SMOOTHFONT)
	If font[n]>0 Then SetImageFont font[n]
Next


Global SpriteX,SpriteY
Global w,h
w=SpriteWidth;h=SpriteHeight
SeedRnd(MilliSecs());For n=0 To 100;r=Rnd(0,10);Next

Repeat
Cls

For SpriteY=0 To SpritesY-1
For SpriteX=0 To SpritesX-1
ResetDraw()
SetViewport(SpriteX*SpriteWidth,SpriteY*SpriteHeight,SpriteWidth,SpriteHeight)
SetOrigin(SpriteX*SpriteWidth,SpriteY*SpriteHeight)
w=SpriteWidth;h=SpriteHeight
SetColor((MaskColor & $FF0000) Shr 16,(MaskColor & $00FF00) Shr 8,(MaskColor & $0000FF))
DrawRect(dx,dy,w,h)

ResetDraw()
Generator()


SetViewport(0,0,ScreenWidth,ScreenHeight)
SetOrigin(0,0)
Flip
Next
Next

outimg=GrabPixmap(0,0,ScreenWidth,ScreenHeight)
For x=0 To ScreenWidth-1
For y=0 To ScreenHeight-1
	argb=ReadPixel(outimg,x,y)
	If (argb & $00FFFFFF)=MaskColor Then argb=$00000000
	WritePixel(outimg,x,y,argb)
Next
Next

If Rescale=0
	SavePixmapPNG(outimg,OutFilename+".png")
EndIf

If Rescale=1
	SavePixmapPNG(outimg,OutFilename+"-hd2.png")
	outimg_2=ResizePixmap(outimg,ScreenWidth/2,ScreenHeight/2)
	SavePixmapPNG(outimg_2,OutFilename+"-hd.png")
	outimg_1=ResizePixmap(outimg,ScreenWidth/4,ScreenHeight/4)
	SavePixmapPNG(outimg_1,OutFilename+".png")
EndIf

If Rescale=2
	SavePixmapPNG(outimg,OutFilename+".png")
	outimg_2=CreatePixmap(ScreenWidth*2,ScreenHeight*2,PF_RGBA8888)
	outimg_4=CreatePixmap(ScreenWidth*4,ScreenHeight*4,PF_RGBA8888)
	
	For x=0 To ScreenWidth-1
	For y=0 To ScreenHeight-1
		argb=ReadPixel(outimg,x,y)
	
		WritePixel(outimg_2,x*2,y*2,argb)
		WritePixel(outimg_2,x*2,y*2+1,argb)
		WritePixel(outimg_2,x*2+1,y*2,argb)
		WritePixel(outimg_2,x*2+1,y*2+1,argb)

		For ex=0 To 3
		For ey=0 To 3
			WritePixel(outimg_4,x*4+ex,y*4+ey,argb)
		Next
		Next
		
	Next
	Next
	
	SavePixmapPNG(outimg_2,OutFilename+"-hd.png")
	SavePixmapPNG(outimg_4,OutFilename+"-hd2.png")
EndIf

SetImageFont font[4]
DrawText("Finished",20,20)
DrawText("R to Redraw",20,50)
DrawText("Any other key to Quit",20,80)
Flip
WaitKey()
Until Not KeyDown(KEY_R)

' -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
' Generator code goes below!
' -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

Rem
    Float v = 0.0;
    vec2 c = v_coords * u_k - u_k/2.0;
    v += Sin((c.x+u_time));
    v += Sin((c.y+u_time)/2.0);
    v += Sin((c.x+c.y+u_time)/2.0);
    c += u_k/2.0 * vec2(Sin(u_time/3.0), Cos(u_time/2.0));
    v += Sin(sqrt(c.x*c.x+c.y*c.y+1.0)+u_time);
    v = v/2.0;
    vec3 col = vec3(1, Sin(Pi*v), Cos(Pi*v));
    gl_FragColor = vec4(col*.5 + .5, 1);
EndRem

Function Plasma#(x,y)
	v#=0
	x=x*3;y=y*3
	v=Sin(Float(x)+frametick)
	v=v+Sin((Float(y)+frametick)/2.0)
	v=v+Sin((Float(x)+Float(y)+frametick)/2.0)
	
	Return v
End Function


Function Generator()
big=0

frametick=MilliSecs()

' Initial - Find throughline of "h", where the tunnel will pull through the font

For n=0 To 128
	SetImageFont font[n]
	If TextWidth(text$)<w-256  Then big=n
Next

SetImageFont font[big]
SetColor(0,0,0)
DrawRect(0,0,w,h)
SetColor(255,255,255)
SetImageFont font[big]

DrawText("h",0-(TextWidth("h")/2),(h/2)-(TextHeight(text)/2))


SetImageFont font[big]

' Stage One - Draw Text

hub:TPixmap=GrabPixmap(0,0,2,h+1)
top=10800;bot=0
For y=0 To h
	trail[y]=0
	argb=(ReadPixel(hub,0,y) & $000000FF)
	DebugLog argb
	If argb>128
		trail[y]=1
		If y<top Then top=y
		If y>bot Then bot=y
	EndIf
Next

For y=0 To h
	trail[y]=0
	If y>top+2 And y<bot-2 Then trail[y]=1
	
Next

middle=((bot-top)/2)+top

hub=Null
GCCollect()

SetColor((MaskColor & $FF0000) Shr 16,(MaskColor & $00FF00) Shr 8,(MaskColor & $0000FF))
DrawRect(0,0,w,h)

SetColor(255,255,255)
DrawText(text,(w/2)-(TextWidth(text)/2),(h/2)-(TextHeight(text)/2))




' Stage Two - Pull Line
hub2:TPixmap=GrabPixmap(0,0,w,h)

SetColor((MaskColor & $FF0000) Shr 16,(MaskColor & $00FF00) Shr 8,(MaskColor & $0000FF))
DrawRect(0,0,w,h)

For x=0 To w-1
	d=320-(Abs(x-160)*1.5)
	If d<0 Then d=0
	If d>320 Then d=320

	If x>w/2
		d=320-(Abs(x-(w*0.85))*1.25)
	EndIf
	If d<0 Then d=0
	If d>320 Then d=320
	
For y=0 To h-1
	drag=0
	
	ud=(Float(Abs(y-middle))*16.0)-d
	
	If d<120 Then ud=Rand(80,d);If Rand(0,10)<1 Then ud=0
	If d<80 Then ud=Rand(40,d);If Rand(0,10)<3 Then ud=0
	If d<40 Then ud=Rand(0,d);If Rand(0,10)<5 Then ud=0
	If ud>255 Then ud=255
	
	drag=-(Float(ud)/8.0)
	If drag>16 Then drag=16
	If drag<0 Then drag=0

	If x+drag<w And x+drag>-1 And x-drag<w And x-drag>-1
		argb=((ReadPixel(hub2,(x-drag),y) & $0000FF00) Shr 8)
		SetColor(argb,argb,argb)
		If argb>50 Then Plot(x,y)
	EndIf
Next
Next
hub2=Null
GCCollect()

' Stage Three - Add Line
hub2:TPixmap=GrabPixmap(0,0,w,h)
For x=0 To w-1
	d=320-(Abs(x-160)*2.0)
	If d<0 Then d=0
	If d>320 Then d=320

	If x>w/2
		d=320-(Abs(x-(w*0.85))*1.25)
	EndIf
	If d<0 Then d=0
	If d>320 Then d=320
	
For y=0 To h-1
	ud=d-(Float(Abs(y-middle))*12.0)
	
	If d<120 Then ud=Rand(80,d);If Rand(0,10)<1 Then ud=0
	If d<80 Then ud=Rand(40,d);If Rand(0,10)<3 Then ud=0
	If d<40 Then ud=Rand(0,d);If Rand(0,10)<5 Then ud=0
	If ud>255 Then ud=255

	argb=((ReadPixel(hub2,x,y) & $0000FF00) Shr 8)
	If argb>128 Then ud=255

	SetColor(ud,ud,ud)
	
	If ud>0
		If trail[y]>0 Then Plot(x,y)
	EndIf
Next
Next
hub2=Null
GCCollect()

hub2:TPixmap=GrabPixmap(0,0,w,h)

SetColor((MaskColor & $FF0000) Shr 16,(MaskColor & $00FF00) Shr 8,(MaskColor & $0000FF))
DrawRect(0,0,w,h)

For x=0 To w-1
For y=0 To h-1
	d=(ReadPixel(hub2,x,y) & $0000FF00) Shr 8
	fd#=0.75+(Float(d)/750.0)
	
	r#=255*fd
	g#=(200+(Plasma(x,y)*50))*fd
	b#=(Rnd(fd*0.3)*fd)
	
	If r<0 Then r=0
	If r>255 Then r=255
	If g<0 Then g=0
	If g>255 Then g=255
	If b<0 Then b=0
	If b>255 Then b=255	
	
	speckle#=Rnd(0.8,1.0)
	
	
	SetColor(r*speckle,g*speckle,b*speckle)
	If coloured=0 Then SetColor(r,r,r)
	If coloured=-1 Then SetColor(1,1,1)
	
'	SetColor(Rnd(fd*0.5,fd),Rnd(fd*0.3,fd*0.9),Rnd(fd*0,fd*0.3))
	
	If d>20 Then Plot x,y
Next
Next

hub2=Null
GCCollect()






SetColor(255,255,255)
End Function